import { Meta, Typeset, Story, Canvas } from '@storybook/blocks';
import { width } from './util/decorator';
import { cuiDemo } from './util/demo';
import { demoHead1, demoHead2, demoInline, demoBlockquote1, demoBlockquote2, demoList1, demoList2, demoTable, demoText } from './util/typography';
import * as TypographyTypographyStories from './Typography-typography.stories';

<Meta of={TypographyTypographyStories} />

# Typography

**Sans Serif Pro** is used as a default typeface for all text and interface elements. A distinction is made between headings and body text. Although the same typeface is used for both, they can be styled differently by using **CSS custom properties**.

> **IMPORTANT:** Due to compatibility issues, all implicit CSS rules are only applied within containers with the `.cui-typo` class attached.

## Headings

All HTML headings, `<h1>` through `<h6>`, are available.

<Canvas withSource="open">
  <Story of={TypographyTypographyStories.Headings} />
</Canvas>

`.cui-h1` through `.cui-h6` classes are also available, for when you want to match the font styling of a heading but cannot use the associated HTML element.

`cui-head({1-6})` can also be used as **mixin**.

<Canvas withSource="open">
  <Story of={TypographyTypographyStories.HeadingsCss} />
</Canvas>

## Text

`.cui-text-xl` through `.cui-text-xs` classes are available, for when you want to scale the text.

`cui-text({xl-xs})` can also be used as **mixin**.

<Canvas withSource="open">
  <Story of={TypographyTypographyStories.Text} />
</Canvas>

## Inline text elements

Styling for common inline HTML5 elements.

<Canvas withSource="open">
  <Story of={TypographyTypographyStories.InlineTextElements} />
</Canvas>

Beware that those tags should be used for semantic purpose:

* `<mark>` represents text which is marked or highlighted for reference or notation purposes.
* `<small>` represents side-comments and small print, like copyright and legal text.
* `<s>` represents element that are no longer relevant or no longer accurate.
* `<u>` represents a span of inline text which should be rendered in a way that indicates that it has a non-textual annotation.

If you want to style your text, you should use the following classes instead:

* `.cui-strong` will apply the same styles as `<strong>`.
* `.cui-mark` will apply the same styles as `<mark>`.
* `.cui-small` will apply the same styles as `<small>`.
* `.cui-underline` will apply the same styles as `<u>`.
* `.cui-line-through` will apply the same styles as `<s>`.

While not shown above, feel free to use `<b>` and `<i>` in HTML5. `<b>` is meant to highlight words or phrases without conveying additional importance, while `<i>` is mostly for voice, technical terms, etc.
